
Structure GETTEXTLENGTHEX
  flags.l
  codepage.l
EndStructure

Global *CallbackBuffer, CallbackBufferLength


Procedure.l StreamCallBack(dwCookie.l, pbBuff.l, cb.l, *pcb.l)
  If CallbackBufferLength = 0
    ProcedureReturn 1
  EndIf
  
  If CallbackBufferLength > cb
    CopyMemory(*CallbackBuffer, pbBuff, cb)
    PokeL(*pcb, cb)
    CallbackBufferLength-cb
    *CallbackBuffer+cb
  Else
    CopyMemory(*CallbackBuffer, pbBuff, CallbackBufferLength)
    PokeL(*pcb, CallbackBufferLength)
    CallbackBufferLength = 0
  EndIf
  ProcedureReturn 0
EndProcedure


Procedure RichEdit_StreamIn(*Buffer,BufferLength,Mode)
   *CallbackBuffer       = *Buffer
    CallbackBufferLength = BufferLength

    StreamStructure.EDITSTREAM\pfnCallback = @StreamCallBack()
    SendMessage_(GadgetID(4),#EM_STREAMIN,Mode,StreamStructure)
EndProcedure


Procedure LoadRTF(File$)
  If ReadFile(1,File$)
    fLength = Lof()
    *mem = AllocateMemory(1,fLength,0)
    If *mem
      ReadData(*mem,fLength)
      RichEdit_StreamIn(*mem,fLength,#SF_RTF)
      SetGadgetText(1,"")
      range.CHARRANGE
      range\cpMin = 0
      range\cpMax = -1
      SendMessage_(GadgetID(1),#EM_EXSETSEL,0,range)
      SendMessage_(GadgetID(1),#EM_REPLACESEL,#TRUE,*mem)
      FreeMemory(1)
      SetWindowText_(WindowID(),"RichText - "+File$)
    EndIf
    CloseFile(1)
  EndIf
EndProcedure


Procedure.s AppPath()
  ExePath$ = Space(1024)
  GetModuleFileName_(0,ExePath$,1024)
  ProcedureReturn GetPathPart(ExePath$)
EndProcedure


CreateImage(1,20,20)

CreateImage(2,20,20)
  StartDrawing(ImageOutput())
    Box(0,0,20,20,RGB($FF,$FF,$00))
  StopDrawing()

CreateImage(3,20,20)
  StartDrawing(ImageOutput())
    Box(0,0,20,20,RGB($64,$64,$64))
  StopDrawing()


hFont1 = LoadFont(1,"Lucida Console",14)

OpenWindow(0,0,0,1024,768,#PB_WINDOW_SYSTEMMENU|#PB_WINDOW_SCREENCENTERED|#PB_WINDOW_INVISIBLE|#PB_WINDOW_MINIMIZEGADGET,"RichText")
  CreateGadgetList(WindowID())
  StringGadget(1,5,5,1014,300,"",#PB_String_Multiline|#ES_AUTOHSCROLL|#ES_AUTOVSCROLL|#WS_HSCROLL|#WS_VSCROLL)
    SetGadgetFont(1,hFont1)
    SendMessage_(GadgetID(1),#EM_LIMITTEXT,1000000,0)

  ButtonGadget(2,  5,310,130,20,">> RichEdit StreamIn")
  ButtonGadget(5,140,310,130,20,">> Text SreamIn")
  ButtonGadget(3,275,310,130,20,"Clear Edit")
  ButtonGadget(9,410,310,130,20,"Clear RichEdit")

  ButtonGadget(10,600,310,100,20,">> Load .RTF")
  ButtonGadget(11,705,310,100,20,"<< Save .RTF")
  
  ButtonGadget(12,810,310,80,20,"Protected",#PB_Button_Toggle)

  ButtonImageGadget( 6,895,310,20,20,UseImage(1))
  ButtonImageGadget( 7,920,310,20,20,UseImage(2))
  ButtonImageGadget( 8,945,310,20,20,UseImage(3))
  ButtonGadget     (13,970,310,47,20,"default")
  
  EditorGadget(4,5,335,1014,430)
    SetGadgetFont(4,hFont1)
    SendMessage_(GadgetID(4),#EM_SETBKGNDCOLOR,0,RGB($64,$64,$64))
    SendMessage_(GadgetID(4),#EM_EXLIMITTEXT  ,0,1000000)
    SendMessage_(GadgetID(4),#EM_AUTOURLDETECT,#TRUE,0)
    SendMessage_(GadgetID(4),#EM_SETOPTIONS   ,#ECOOP_SET,#ECO_AUTOWORDSELECTION|#ECO_AUTOVSCROLL|#ECO_AUTOHSCROLL|#ECO_READONLY|#ECO_SELECTIONBAR)
    SendMessage_(GadgetID(4),#EM_SETMARGINS,#EC_LEFTMARGIN,0)
    ;SendMessage_(GadgetID(4),#EM_SETTYPOGRAPHYOPTIONS,#TO_ADVANCEDTYPOGRAPHY,#TO_ADVANCEDTYPOGRAPHY)
    ;#SES_EXTENDBACKCOLOR = 4
    ;SendMessage_(GadgetID(4),#EM_SETEDITSTYLE,#SES_EXTENDBACKCOLOR,#SES_EXTENDBACKCOLOR)
  UpdateWindow_(GadgetID(4))
  ;DisableGadget(4,1)

  RemoveKeyboardShortcut(0,-1)
  AddKeyboardShortcut(0,#PB_Shortcut_F5,105)
  AddKeyboardShortcut(0,#PB_Shortcut_F6,106)

  File$ = ProgramParameter()
  If File$
    LoadRTF(File$)
    SetWindowText_(WindowID(),"RichText - "+File$)
  EndIf

HideWindow(0,0)

Repeat
  Select WaitWindowEvent()
    Case #PB_Event_CloseWindow
      End
    Case #PB_Event_Gadget
      Select EventGadgetID()
        Case 2
          A$ = GetGadgetText(1)
          RichEdit_StreamIn(@A$,Len(A$),#SF_RTF)
        Case 5
          A$ = GetGadgetText(1)
          RichEdit_StreamIn(@A$,Len(A$),#SF_TEXT)
          SetGadgetFont(4,hFont1)
        Case 3
          SetGadgetText(1,"")
        Case 9
          SetGadgetText(4,"")
        Case 6
          SendMessage_(GadgetID(4),#EM_SETBKGNDCOLOR,0,RGB($00,$00,$00))
        Case 7
          SendMessage_(GadgetID(4),#EM_SETBKGNDCOLOR,0,RGB($FF,$FF,$00))
        Case 8
          SendMessage_(GadgetID(4),#EM_SETBKGNDCOLOR,0,RGB($64,$64,$64))
        Case 13 ; Default System Color
          SendMessage_(GadgetID(4),#EM_SETBKGNDCOLOR,#TRUE,0)
        Case 10 ; Load RTF
          File$ = OpenFileRequester("Open RTF",AppPath(),"RichText|*.RTF",1)
          If File$
            LoadRTF(File$)
          EndIf
        Case 11 ; Save RTF
          File$ = SaveFileRequester("Save RTF",AppPath(),"RichText|*.RTF",1)
          If File$
            If UCase(Right(File$,4)) <> ".RTF"
              File$ + ".RTF"
            EndIf
            linecount = SendMessage_(GadgetID(1),#EM_GETLINECOUNT,0,0)
            If linecount
              If CreateFile(1,File$)
                For line = 0 To linecount-1
                  EdLine$ = Space(30000)
                  PokeW(@EdLine$,30000)
                  chars = SendMessage_(GadgetID(1),#EM_GETLINE,line,@EdLine$)
                  If chars
                    WriteData(@EdLine$,chars)
                    WriteStringN("")
                  Else
                    WriteStringN("")
                  EndIf
                Next line
                CloseFile(1)
                SetWindowText_(WindowID(),"RichText - "+File$)
              EndIf
            EndIf
          EndIf
        Case 12 ; Protect \ UnProtect
          Select GetGadgetState(12)
            Case 0
              SetGadgetText(12,"Protected")
              SendMessage_(GadgetID(4),#EM_SETOPTIONS,#ECOOP_SET,#ECO_AUTOWORDSELECTION|#ECO_AUTOVSCROLL|#ECO_AUTOHSCROLL|#ECO_SELECTIONBAR|#ECO_READONLY)
            Case 1
              SetGadgetText(12,"UnProtected")
              SendMessage_(GadgetID(4),#EM_SETOPTIONS,#ECOOP_SET,#ECO_AUTOWORDSELECTION|#ECO_AUTOVSCROLL|#ECO_AUTOHSCROLL|#ECO_SELECTIONBAR)
          EndSelect
      EndSelect
    Case #PB_Event_Menu
      Select EventMenuID()
        Case 105
          Beep_(800,50)
          A$ = GetGadgetText(1)
          RichEdit_StreamIn(@A$,Len(A$),#SF_RTF)
        Case 106
          Beep_(600,50)
          A$ = GetGadgetText(1)
          RichEdit_StreamIn(@A$,Len(A$),#SF_TEXT)
          SetGadgetFont(4,hFont1)
      EndSelect
  EndSelect
ForEver

; ExecutableFormat=Windows
; CursorPosition=107
; FirstLine=87
; Executable=C:\Documents and Settings\Administrator\Desktop\RTF Spec\PureBasic\RichText.exe
; EOF